<!--
  ~ Benchmarking Suite
  ~ Copyright 2014-2022 Engineering Ingegneria Informatica S.p.A.
  ~
  ~ Licensed under the Apache License, Version 2.0 (the "License");
  ~ you may not use this file except in compliance with the License.
  ~ You may obtain a copy of the License at
  ~
  ~ http://www.apache.org/licenses/LICENSE-2.0
  ~
  ~ Unless required by applicable law or agreed to in writing, software
  ~ distributed under the License is distributed on an "AS IS" BASIS,
  ~ WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  ~ See the License for the specific language governing permissions and
  ~ limitations under the License.
  -->

<template>

  <v-container>

    <v-row dense>
      <v-col cols="6" >
         <v-select
          :items="providerTechnologies"
          label="Provider technology"
          v-model="provider.driver"
          :rules="technologyRules"
        ></v-select>
      </v-col>
    </v-row>
    <v-row
      dense
    >
      <v-col cols="6" >
        <v-text-field
          label="Host"
          hint="Endpoint of the Kubernetes ApiServer"
          v-model="provider.api_server_url"
          :rules="apiServerUrlRules"
        ></v-text-field>
      </v-col>
    </v-row>
    <v-row dense>
      <v-col cols="6" >
        <v-textarea
          label="Server CA Cert"
          hint="certificate"
          v-model="provider.host_cert"
          :rules="caCertRules"
        ></v-textarea>
      </v-col>
    </v-row>

    <v-row dense>
      <v-col cols="3" >
        <v-select
          label="Auth Method"
          :items="authMethods"
          v-model="provider.auth_method"
        >
        </v-select>
      </v-col>
    </v-row>

    <v-container v-if="provider.auth_method == 'userToken'">
      <v-row dense>
        <v-col cols="6" >
          <v-text-field
            label="User Token"
            hint="The username to use to connect"
            v-model="provider.user_token"
            type="password"
            :rules="userTokenRules"
          ></v-text-field>
        </v-col>
      </v-row>
    </v-container>

    <v-container v-if="provider.auth_method == 'clientCertificate'">
      <v-row dense>
        <v-col cols="6" >
          <v-textarea
            label="Client Cert"
            hint="Client  Certificate"
            v-model="provider.client_cert"
            :rules="userTokenRules"
          ></v-textarea>
        </v-col>
      </v-row>
      <v-row dense>
        <v-col cols="6" >
          <v-textarea
            label="Client Key"
            hint="Client Certificate"
            v-model="provider.client_key"
            :rules="userTokenRules"
          ></v-textarea>
        </v-col>
      </v-row>
    </v-container>

    <v-row dense>
      <v-col cols="6" >
        <v-text-field
          label="Namespace"
          hint="The namespace"
          v-model="provider.namespace"
          :rules="namespaceRules"
        ></v-text-field>
      </v-col>
    </v-row>
    <v-row dense>
      <v-col cols="3" >
        <v-select
          label="Node Testing Strategy"
          :items="testingStrategyItems"
          v-model="provider.nodes_testing_strategy"
        >
        </v-select>
      </v-col>
      <v-col cols="3">
        <v-text-field
          v-if="provider.nodes_testing_strategy == 'from_list'"
          label="Nodes List"
          hint="List of Nodes to test"
          v-model="provider.nodes_to_test"
          :rules="nodeListRules"
        ></v-text-field>
      </v-col>
    </v-row>
  </v-container>
</template>

<script>

export default {

  name: 'KubernetesConnectionEditor',

  props: {
    provider: {
      type: Object,
      default: function() {return {}}
    },
    providerTechnologies: {
      type: Array,
      default: function() {return []}
    }
  },

  data: () => ({

    authMethods: [
      {text: 'User Token', value: 'userToken'},
      {text: 'Client Certificate', value: 'clientCertificate'}
    ],

    testingStrategyItems: [
      {text: 'No choice', value: null},
      {text: 'Test all nodes', value: 'autodiscovered'},
      {text: 'Test nodes from list', value: 'from_list'}
    ],

    technologyRules: [
        v => !!v || 'A cloud provider technology must be selected'
      ],
    apiServerUrlRules : [
        v => !!v || 'A connection host is required',
        v => (v && v.trim().length > 0) || 'A connection host is required'
      ],
    caCertRules : [
        // v => !!v || (v && v.trim().length > 0) ||'A user name is required',
        // v => (v && v.trim().length > 0) || 'A user name is required'
      ],
    userTokenRules : [
        v => !!v || 'A password/secret is required'
      ],
    namespaceRules : [
        v => !!v || 'A password/secret is required'
      ],
    nodeListRules : [
        v => !!v || 'Nodelist is requried if strategy is "from list"'
      ]
  })
};

</script>
